/*****************************************************************
	T. Jayaraman 
	September, 1996.
	Application to create font using CreateFontEx.
*****************************************************************/

#include "windows.h"
#include <stdlib.h>
#include "generic.h"
#include "font.h"
#include "resource.h"

HANDLE hInst;
HWND            hWnd;   

/****************************************************************************/

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, 
								LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;

	if (!hPrevInstance)
	if (!InitApplication(hInstance))
		return (FALSE);

	if (!InitInstance(hInstance, nCmdShow))
		return (FALSE);

	while (GetMessage(&msg,	NULL, NULL,	NULL)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return (msg.wParam);
}


/*******************************************************************/
BOOL InitApplication(HANDLE hInstance)
{
    WNDCLASS  wc;

    wc.style = NULL;
    wc.lpfnWndProc = MainWndProc;
    wc.cbClsExtra = 0; 
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH); 
    wc.lpszMenuName =  "GenericMenu";
    wc.lpszClassName = "GenericWClass";

    return (RegisterClass(&wc));

}

/********************************************************************/
BOOL InitInstance(HANDLE hInstance, int nCmdShow)
{
    hInst = hInstance;

    hWnd = CreateWindow(
        "GenericWClass",
        "Font Test Sample Application",
        WS_OVERLAPPEDWINDOW,            // Window style.
        CW_USEDEFAULT,                  // x
        CW_USEDEFAULT,                  // y
        CW_USEDEFAULT,                  // cx
        CW_USEDEFAULT,                  // cy
        NULL,                           // Parent Handle
        NULL,                           // Menu or child id.
        hInstance,                      // hInstance
        NULL                            // NULL.
    );

    if (!hWnd)
        return (FALSE);

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);       
    return (TRUE);           

}

/******************************************************************/
long FAR PASCAL MainWndProc(HWND hWnd, unsigned message, WORD wParam,
												LONG lParam)
{
    FARPROC lpProcAbout;

    switch (message) {
	case WM_COMMAND:
		switch (wParam) {
		case IDM_ABOUT:
			lpProcAbout = MakeProcInstance(About, hInst);
			DialogBox(hInst, "AboutBox", hWnd, lpProcAbout);
			FreeProcInstance(lpProcAbout);
			break;
	    }
		break;

	case WM_DESTROY:
	    PostQuitMessage(0);
	    break;

	default:
	    return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return (NULL);
}


/*********************************************************************/
BOOL FAR PASCAL About(HWND hDlg, unsigned message, 
					WORD wParam, LONG lParam)
{
   char pszFontName[25];
   char pszFontSize[5];
	HFONT hFont;
   
    switch (message) {
		case WM_INITDIALOG:
		    return (TRUE);
	
		case WM_COMMAND:
		   switch (wParam) {
		   	case IDOK:
		   	case IDCANCEL:
					EndDialog(hDlg, TRUE);
					break;
				case IDC_BTNFONT:
					GetDlgItemText(hDlg ,IDC_EDFONTNAME , pszFontName , 25);
					GetDlgItemText(hDlg ,IDC_EDFONTSIZE , pszFontSize , 5);
// Calling our function to create the font.
					hFont = CreateFontEx(pszFontName , 
						(int)atoi(pszFontSize), 
						FALSE, FALSE, FALSE, FALSE);
					if (hFont) {
						SendDlgItemMessage (hDlg, IDC_EDFONTTEST, 
							WM_SETFONT,	(WPARAM)hFont, MAKELONG (1, 0));
						SetDlgItemText(hDlg ,IDC_EDFONTTEST, pszFontName); 	                     
			   	}
			   	break;
			}
		   break;
		default:				// Not processed.
			return FALSE;
    }
    return (TRUE);
}
